{
  Status
  2 steht für Wiedergabe, 1 für Pause und 0 für Ruhezustand.
}

unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,LibUSB,
  ComCtrls,Tools,Process, Buttons, ExtCtrls,Unit2;

type

  { TForm1 }

  TDataItem = class
    commando,commando2:String;
  end;
  
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    Label1: TLabel;
    Label5: TLabel;
    ListView1: TListView;
    Memo1: TMemo;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    TabSheet1: TTabSheet;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListView1DblClick(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { private declarations }
  public
    procedure LoadComandos(Script:String);
    procedure RunComa;
    { public declarations }
  end; 

var
  Form1: TForm1; 

implementation

{ TForm1 }


procedure runApp(FileName:String;outDaten:TStrings);
var
  AProcess:TProcess;
begin
  AProcess := TProcess.Create(nil);
  AProcess.CommandLine :=FileName;
  aProcess.Options := AProcess.Options + [poUsePipes];
  AProcess.Execute;

  if outDaten <> NIL then
    outDaten.LoadFromStream(AProcess.Output);

  AProcess.Free;
end;

procedure TForm1.RunComa;
begin
  if ListView1.Selected <> NIL then begin
    runApp(TDataItem(ListView1.Selected.Data).commando,NIL);

    if TDataItem(ListView1.Selected.Data).commando2 <> '' then
      runApp(TDataItem(ListView1.Selected.Data).commando2,Memo1.Lines);
  end
end;

procedure TForm1.LoadComandos(Script:String);
var
  i:Integer;
  Inhalt:TStringlist;
  DataItem:TDataItem;
begin
  Inhalt:=TStringlist.Create;
  if FileExists(Script) = True then begin
    Inhalt.LoadFromFile(Script);
  end
  else begin
    inhalt.add('dcop amarok player play;Play;0;dcop amarok player status;');
inhalt.add('dcop amarok player stop;Stop;1;dcop amarok player status;');
inhalt.add('dcop amarok player playPause;Pause;2;dcop amarok player status;');
inhalt.add('dcop amarok player next;Weiter;3;');
inhalt.add('dcop amarok player mute;Ruhe;4;');
inhalt.add('dcop amarok player prev;Zurück;5;');
inhalt.add('dcop amarok player volumeDown;leiser um einen schritt;6;dcop amarok player getVolume');
inhalt.add('dcop amarok player volumeUp;erhöt die lautstärke um einen schritt;7;dcop amarok player getVolume');
inhalt.add('dcop amarok player enableRandomMode;Wählt zufllig stücke aus in der Playliste;8;');
inhalt.add('dcop amarok playlist addMediaList;Dateien hinzufügen;9;');
inhalt.add('dcop amarok playlist clearPlaylist;Einträge inder playlist löschen;10;');
inhalt.add('halt;Rechner ausschalten;11;');
inhalt.add('restart;Rechner neustarten;12;');

  end;

     for i:=0 to Inhalt.Count-1 do begin
       DataItem:=TDataItem.Create;
       DataItem.commando:=GetToken(Inhalt.Strings[i],';',1);
       with ListView1.Items.add do begin
         DataItem.commando2:=GetToken(Inhalt.Strings[i],';',4);
         Data:=DataItem;

         if Pos('dcop amarok',DataItem.commando) > 0 then
           Caption:=StringReplace(DataItem.commando,'dcop amarok ','',[]) // Anweisung
         else
           Caption:=DataItem.commando;

         SubItems.add(GetToken(Inhalt.Strings[i],';',3)); // Freq
         SubItems.add(GetToken(Inhalt.Strings[i],';',2)); // Beschreibung
         SubItems.add(GetToken(Inhalt.Strings[i],';',4)); // Beschreibung

       end;
     end;
//  else
//   ShowMEssage('Datei wurde nicht gefunden' + #13 + '"' + Script + '"');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadComandos('befehle.txt');
end;

procedure TForm1.ListView1DblClick(Sender: TObject);
begin

  if ListView1.Selected <> NIL then begin
    Form2.Edit1.Text:=ListView1.Selected.Caption;
    Form2.Edit2.Text:=ListView1.Selected.SubItems.strings[0];
    Form2.Edit3.Text:=ListView1.Selected.SubItems.strings[2];
    if Form2.ShowModal = mrOK then begin
    end;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin

end;

procedure TForm1.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if Selected = true then
    Caption:=TDataItem(item.Data).commando;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin

end;

initialization
  {$I unit1.lrs}

end.

